import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.SimpleUniverse;
import javax.media.j3d.*;
import javax.vecmath.*;


public class Vorguliiklus3d3 extends Applet implements KeyListener, Runnable{

  BufferedReader sisse;
  PrintWriter valja;
  String masin="localhost";
  int port=3001;
  String nimi="Jaagup";
  HashMap inimesed=new HashMap();
  BranchGroup juur;

  public Vorguliiklus3d3(){
   try{
    setLayout(new BorderLayout());
    Canvas3D c = new Canvas3D(
     SimpleUniverse.getPreferredConfiguration());
    add(c, BorderLayout.CENTER);
	
    juur = new BranchGroup();
    juur.setCapability(
        TransformGroup.ALLOW_CHILDREN_WRITE);

    SimpleUniverse u = new SimpleUniverse(c);
    u.getViewingPlatform().setNominalViewingTransform();
    u.addBranchGraph(juur);



    c.addKeyListener(this);
    Socket sc=new Socket(masin, port);
    valja=new PrintWriter(sc.getOutputStream(), true);
    sisse=new BufferedReader(
      new InputStreamReader(sc.getInputStream())
    );
    System.out.println(sisse.readLine());
    valja.println(nimi);
    new Thread(this).start();
   }catch(Exception viga){
     viga.printStackTrace();
   }
  }

  public void run(){
     while(true){
      try{
       String rida=sisse.readLine();
       StringTokenizer stk=new StringTokenizer(rida);
       int x=Integer.parseInt(stk.nextToken());
       int y=Integer.parseInt(stk.nextToken());
       String nimi=stk.nextToken();
       if(inimesed.get(nimi)==null){
           BranchGroup oks=new BranchGroup();
           TransformGroup nihe=new TransformGroup();
           oks.insertChild(nihe, 0);
           nihe.addChild(new ColorCube(0.3));
           nihe.setCapability(
                 TransformGroup.ALLOW_TRANSFORM_WRITE);
           oks.compile();
           juur.insertChild(oks, 0);
           inimesed.put(nimi, nihe);
           System.out.println("Uus kasutaja");
       }
       Transform3D t=new Transform3D();
       t.setTranslation(
          new Vector3d((x-100)/10.0, 0, (y-100)/10.0)
       );
       TransformGroup nihe=(TransformGroup)inimesed.get(nimi);
       nihe.setTransform(t);
      }catch(Exception viga){
        System.out.println(viga);
      }
     }
  }

  public void keyPressed(KeyEvent e){
    int kood=e.getKeyCode();
    if(kood==KeyEvent.VK_LEFT){
      valja.println(".vasakule");
    }
    if(kood==KeyEvent.VK_RIGHT){
      valja.println(".paremale");
    }
    if(kood==KeyEvent.VK_UP){
      valja.println(".yles");
    }
    if(kood==KeyEvent.VK_DOWN){
      valja.println(".alla");
    }
  }

  public void keyReleased(KeyEvent e){}

  public void keyTyped(KeyEvent e){}
  

  public static void main(String argumendid[]){
    Frame f=new Frame("Klahvikuular");
    f.add(new Vorguliiklus3d3());
    f.setSize(300, 300);
    f.setVisible(true);  
  }
}


